searchData={"items":[{"type":"module","title":"Membrane.H264.FFmpeg.Decoder","doc":"Membrane element that decodes video in H264 format. It is backed by decoder from FFmpeg.\n\nThe element expects the data for each frame (Access Unit) to be received in a separate buffer,\nso the parser (`Membrane.H264.Parser`) may be required in a pipeline before\ndecoder (e.g. when input is read from `Membrane.File.Source`).","ref":"Membrane.H264.FFmpeg.Decoder.html"},{"type":"module","title":"Element options - Membrane.H264.FFmpeg.Decoder","doc":"Passed via struct `t:Membrane.H264.FFmpeg.Decoder.t/0`\n\n- `use_shm?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`  \n  If true, native decoder will use shared memory (via `t:Shmex.t/0`) for storing frames","ref":"Membrane.H264.FFmpeg.Decoder.html#module-element-options"},{"type":"module","title":"Pads - Membrane.H264.FFmpeg.Decoder","doc":"### `:input`\n\nAccepted formats:\n```\n%H264{alignment: :au}\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\nDemand unit: | `:buffers`\n\n\n### `:output`\n\nAccepted formats:\n```\n%RawVideo{pixel_format: format, aligned: true} when format in [:I420, :I422]\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`\nDemand unit: | `nil`","ref":"Membrane.H264.FFmpeg.Decoder.html#module-pads"},{"type":"function","title":"Membrane.H264.FFmpeg.Decoder.options/0","doc":"Returns description of options available for this module","ref":"Membrane.H264.FFmpeg.Decoder.html#options/0"},{"type":"type","title":"Membrane.H264.FFmpeg.Decoder.t/0","doc":"Struct containing options for `Membrane.H264.FFmpeg.Decoder`","ref":"Membrane.H264.FFmpeg.Decoder.html#t:t/0"},{"type":"module","title":"Membrane.H264.FFmpeg.Encoder","doc":"Membrane element that encodes raw video frames to H264 format.\n\nThe element expects each frame to be received in a separate buffer, so the parser\n(`Membrane.Element.RawVideo.Parser`) may be required in a pipeline before\nthe encoder (e.g. when input is read from `Membrane.File.Source`).\n\nAdditionally, the encoder has to receive proper stream_format with picture format and dimensions\nbefore any encoding takes place.\n\nPlease check `t:t/0` for available options.","ref":"Membrane.H264.FFmpeg.Encoder.html"},{"type":"module","title":"Element options - Membrane.H264.FFmpeg.Encoder","doc":"Passed via struct `t:Membrane.H264.FFmpeg.Encoder.t/0`\n\n- `crf`  \n\n  ```\n  0..63\n  ```\n  \n  Default value: `23`  \n  Constant rate factor that affects the quality of output stream.\n  Value of 0 is lossless compression while 51 (for 8-bit samples)\n  or 63 (10-bit) offers the worst quality.\n  The range is exponential, so increasing the CRF value +6 results\n  in roughly half the bitrate / file size, while -6 leads\n  to roughly twice the bitrate.\n\n\n- `preset`  \n\n  ```\n  preset()\n  ```\n  \n  Default value: `:medium`  \n  Collection of predefined options providing certain encoding.\n  The slower the preset chosen, the higher compression for the\n  same quality can be achieved.\n\n\n\n- `profile`  \n\n  ```\n  H264.profile() | nil\n  ```\n  \n  Default value: `nil`  \n  Sets a limit on the features that the encoder will use to the ones supported in a provided H264 profile.\n  Said features will have to be supported by the decoder in order to decode the resulting video.\n  It may override other, more specific options affecting compression (e.g setting `max_b_frames` to 2\n  while profile is set to `:baseline` will have no effect and no B-frames will be present).\n\n\n\n- `tune`  \n\n  ```\n  tune() | nil\n  ```\n  \n  Default value: `nil`  \n  Optionally tune the encoder settings for a particular type of source or situation.\n  See [`x264` encoder's man page](https://manpages.ubuntu.com/manpages/trusty/man1/x264.1.html) for more info.\n  Available options are:\n  - `:film` - use for high quality movie content; lowers deblocking\n  - `:animation` - good for cartoons; uses higher deblocking and more reference frames\n  - `:grain` - preserves the grain structure in old, grainy film material\n  - `:stillimage` - good for slideshow-like content\n  - `:fastdecode` - allows faster decoding by disabling certain filters\n  - `:zerolatency` - good for fast encoding and low-latency streaming\n\n\n\n- `use_shm?`  \n\n  ```\n  boolean()\n  ```\n  \n  Default value: `false`  \n  If true, native encoder will use shared memory (via `t:Shmex.t/0`) for storing frames\n\n\n\n- `max_b_frames`  \n\n  ```\n  non_neg_integer() | nil\n  ```\n  \n  Default value: `nil`  \n  Maximum number of B-frames between non-B-frames. Set to 0 to encode video without b-frames\n\n\n\n- `gop_size`  \n\n  ```\n  non_neg_integer() | nil\n  ```\n  \n  Default value: `nil`  \n  Number of frames in a group of pictures.\n\n\n\n- `sc_threshold`  \n\n  ```\n  non_neg_integer()\n  ```\n  \n  Default value: `40`  \n  Sets the threshold for scene change detection. This determines how aggressively `x264`\n  will try to insert extra I-frames (higher values increase the number of scene changes detected).\n  Set to 0 to disable scene change detection (no extra I-frames will be inserted).\n  See [this page](https://en.wikibooks.org/wiki/MeGUI/x264_Settings#scenecut) for more info.","ref":"Membrane.H264.FFmpeg.Encoder.html#module-element-options"},{"type":"module","title":"Pads - Membrane.H264.FFmpeg.Encoder","doc":"### `:input`\n\nAccepted formats:\n```\n%RawVideo{pixel_format: format, aligned: true} when format in [:I420, :I422]\n```\n\nDirection: | `:input`\nAvailability: | `:always`\nFlow control: | `:auto`\nDemand unit: | `:buffers`\n\n\n### `:output`\n\nAccepted formats:\n```\n%H264{alignment: :au}\n```\n\nDirection: | `:output`\nAvailability: | `:always`\nFlow control: | `:auto`\nDemand unit: | `nil`","ref":"Membrane.H264.FFmpeg.Encoder.html#module-pads"},{"type":"function","title":"Membrane.H264.FFmpeg.Encoder.options/0","doc":"Returns description of options available for this module","ref":"Membrane.H264.FFmpeg.Encoder.html#options/0"},{"type":"type","title":"Membrane.H264.FFmpeg.Encoder.preset/0","doc":"","ref":"Membrane.H264.FFmpeg.Encoder.html#t:preset/0"},{"type":"type","title":"Membrane.H264.FFmpeg.Encoder.t/0","doc":"Struct containing options for `Membrane.H264.FFmpeg.Encoder`","ref":"Membrane.H264.FFmpeg.Encoder.html#t:t/0"},{"type":"type","title":"Membrane.H264.FFmpeg.Encoder.tune/0","doc":"","ref":"Membrane.H264.FFmpeg.Encoder.html#t:tune/0"},{"type":"extras","title":"Membrane H264 FFmpeg plugin","doc":"# Membrane H264 FFmpeg plugin\n\n[![Hex.pm](https://img.shields.io/hexpm/v/membrane_h264_ffmpeg_plugin.svg)](https://hex.pm/packages/membrane_h264_ffmpeg_plugin)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/membrane_h264_ffmpeg_plugin/)\n[![CircleCI](https://circleci.com/gh/membraneframework/membrane_h264_ffmpeg_plugin.svg?style=svg)](https://circleci.com/gh/membraneframework/membrane_h264_ffmpeg_plugin)\n\nThis package provides H264 video decoder and encoder, based on [ffmpeg](https://www.ffmpeg.org)\nand [x264](https://www.videolan.org/developers/x264.html).\n\nIt is a part of the [Membrane Multimedia Framework](https://membraneframework.org)\n\nDocumentation is available at [HexDocs](https://hexdocs.pm/membrane_h264_ffmpeg_plugin/)\n\nNote: `Membrane.H264.FFmpeg.Parser` has been removed. Now you can use our pure Elixir implementation of the H264 parser: [`Membrane.H264.Parser`](https://hexdocs.pm/membrane_h264_plugin/Membrane.H264.Parser.html) from [membrane_h264_plugin](https://github.com/membraneframework/membrane_h264_plugin).","ref":"readme.html"},{"type":"extras","title":"Installation - Membrane H264 FFmpeg plugin","doc":"Add the following line to your `deps` in `mix.exs`. Run `mix deps.get`.\n\n```elixir\n{:membrane_h264_ffmpeg_plugin, \"~> 0.30.1\"}\n```\n\nThis package depends on the [ffmpeg](https://www.ffmpeg.org) libraries. The precompiled builds will be pulled and linked automatically. However, should there be any problems, consider installing it manually.\n\n#","ref":"readme.html#installation"},{"type":"extras","title":"Manual instalation of dependencies - Membrane H264 FFmpeg plugin","doc":"##","ref":"readme.html#manual-instalation-of-dependencies"},{"type":"extras","title":"Ubuntu - Membrane H264 FFmpeg plugin","doc":"```bash\nsudo apt-get install libavcodec-dev libavformat-dev libavutil-dev\n```\n\n##","ref":"readme.html#ubuntu"},{"type":"extras","title":"Arch/Manjaro - Membrane H264 FFmpeg plugin","doc":"```bash\npacman -S ffmpeg\n```\n\n##","ref":"readme.html#arch-manjaro"},{"type":"extras","title":"MacOS - Membrane H264 FFmpeg plugin","doc":"```bash\nbrew install ffmpeg\n```","ref":"readme.html#macos"},{"type":"extras","title":"Usage Example - Membrane H264 FFmpeg plugin","doc":"#","ref":"readme.html#usage-example"},{"type":"extras","title":"Decoder - Membrane H264 FFmpeg plugin","doc":"The following pipeline takes 30fps H264 file and decodes it to the raw video.\n\n```elixir\nLogger.configure(level: :info)\n\nMix.install([\n  :membrane_h264_ffmpeg_plugin,\n  :membrane_h264_plugin,\n  :membrane_file_plugin,\n  :req\n])\n\nh264 = Req.get!(\"https://raw.githubusercontent.com/membraneframework/static/gh-pages/samples/ffmpeg-testsrc.h264\").body\nFile.write!(\"input.h264\", h264)\n\ndefmodule Decoding.Pipeline do\n  use Membrane.Pipeline\n\n  @impl true\n  def handle_init(_ctx, _opts) do\n    structure =\n      child(%Membrane.File.Source{chunk_size: 40_960, location: \"input.h264\"})\n      |> child(Membrane.H264.Parser)\n      |> child(Membrane.H264.FFmpeg.Decoder)\n      |> child(%Membrane.File.Sink{location: \"output.raw\"})\n\n    {[spec: structure], %{}}\n  end\nend\n\nMembrane.Pipeline.start_link(Decoding.Pipeline)\n```\n\n#","ref":"readme.html#decoder"},{"type":"extras","title":"Encoder - Membrane H264 FFmpeg plugin","doc":"The following pipeline takes 720p raw video file as input and encodes it as H264.\n\n```elixir\ndefmodule Encoding.Pipeline do\n  use Membrane.Pipeline\n\n  @impl true\n  def handle_init(_) do\n    structure =\n      child(:source, %Membrane.File.Source{chunk_size: 40_960, location: \"input.raw\"})\n      |> child(:parser, %Membrane.RawVideo.Parser{width: 1280, height: 720, pixel_format: :I420})\n      |> child(:encoder, %Membrane.H264.FFmpeg.Encoder{preset: :fast, crf: 30})\n      |> child(:sink, %Membrane.File.Sink{location: \"output.h264\"})\n\n    {[spec: structure], %{}}\n  end\nend\n```","ref":"readme.html#encoder"},{"type":"extras","title":"Copyright and License - Membrane H264 FFmpeg plugin","doc":"Copyright 2018, [Software Mansion](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)\n\n[![Software Mansion](https://logo.swmansion.com/logo?color=white&variant=desktop&width=200&tag=membrane-github)](https://swmansion.com/?utm_source=git&utm_medium=readme&utm_campaign=membrane)","ref":"readme.html#copyright-and-license"}],"content_type":"text/markdown"}